Attribute VB_Name = "Export"
Option Explicit
Dim Anzahl As Integer
Dim AnzahlIO As Integer
Dim AnzahlNIO As Integer


Public Sub Export2DWG()

    Dim SuchPfad As String
    Dim LogFile As String
    Anzahl = 0
    AnzahlIO = 0
    AnzahlNIO = 0
    
    'Eingabeabfrage des Suchpfades
    Exportformular.Label1.Caption = "Export von IDWs in DWGs"
    Exportformular.Caption = "Export nach DWG"
    Exportformular.Show
    
    'Abfrage ob gestartet werden soll
    Dim antwort As String
    antwort = MsgBox("Der Export von idw Dateien nach dwg kann mehrere Minuten, " & vbCrLf _
                & "je nach Anzahl der Dateien auch mehrere Stunden dauern." & vbCrLf _
                & " Mchten Sie fortfahren?", vbYesNo, "Achtung!")
    If antwort = vbNo Then Exit Sub
        
        SuchPfad = Exportformular.Pfad
        If Right(SuchPfad, 1) = "\" Then SuchPfad = Left(SuchPfad, Len(SuchPfad) - 1)
        

        
        ' Log-File-Generieren
        Dim fs, log
        Dim logfilename
        Set fs = CreateObject("Scripting.FileSystemObject")
        logfilename = SuchPfad & "\DWG-Export_" & Date & ".log"
        Set log = fs.CreateTextFile(logfilename, True)
        
        log.writeline ("Export von IDW in DWG")
        log.writeline ("*********************")
        log.writeline
        log.writeline ("Zu durchsuchendes Verzeichnis: " & SuchPfad)
        log.writeline ("Startdatum: " & Date)
        log.writeline ("Startzeit: " & Time)
        log.writeline
                      
        'Ordnerstruktur durchlaufen
        Call SearchFold(SuchPfad, log, "DWG")
        
        
        log.writeline
        log.writeline
        log.writeline ("Es wurden " & Anzahl & "IDWs gefunden.")
        log.writeline ("Erfolgreich exportierte Dateien: " & AnzahlIO)
        log.writeline ("Nicht erfolgreich exportierte Dateien: " & AnzahlNIO)
        log.writeline
        log.writeline ("Endzeit: " & Time)
    
        MsgBox "Es wurden " & Anzahl & " Dateien bearbeitet." & vbCrLf & _
            AnzahlIO & " Aktionen waren erfolgreich." & vbCrLf & _
            AnzahlNIO & " Aktionen waren nicht erfolgreich."
        
    

End Sub

Public Sub Export2DXF()

    Dim SuchPfad As String
    Dim LogFile As String
    Anzahl = 0
    AnzahlIO = 0
    AnzahlNIO = 0
    
    'Eingabeabfrage des Suchpfades
    Exportformular.Label1.Caption = "Export von IDWs in DXFs"
    Exportformular.Caption = "Export nach DXF"
    Exportformular.Show
    
    'Abfrage ob gestartet werden soll
    Dim antwort As String
    antwort = MsgBox("Der Export von idw Dateien nach dwg kann mehrere Minuten, " & vbCrLf _
                & "je nach Anzahl der Dateien auch mehrere Stunden dauern." & vbCrLf _
                & " Mchten Sie fortfahren?", vbYesNo, "Achtung!")
    If antwort = vbNo Then Exit Sub
        
        SuchPfad = Exportformular.Pfad
        If Right(SuchPfad, 1) = "\" Then SuchPfad = Left(SuchPfad, Len(SuchPfad) - 1)
        

        
        ' Log-File-Generieren
        Dim fs, log
        Dim logfilename
        Set fs = CreateObject("Scripting.FileSystemObject")
        logfilename = SuchPfad & "\DXF-Export_" & Date & ".log"
        Set log = fs.CreateTextFile(logfilename, True)
        
        log.writeline ("Export von IDW in DXF")
        log.writeline ("*********************")
        log.writeline
        log.writeline ("Zu durchsuchendes Verzeichnis: " & SuchPfad)
        log.writeline ("Startdatum: " & Date)
        log.writeline ("Startzeit: " & Time)
        log.writeline
                      
        'Ordnerstruktur durchlaufen
        Call SearchFold(SuchPfad, log, "DXF")
        
        
        log.writeline
        log.writeline
        log.writeline ("Es wurden " & Anzahl & "IDWs gefunden.")
        log.writeline ("Erfolgreich exportierte Dateien: " & AnzahlIO)
        log.writeline ("Nicht erfolgreich exportierte Dateien: " & AnzahlNIO)
        log.writeline
        log.writeline ("Endzeit: " & Time)
    
        MsgBox "Es wurden " & Anzahl & " Dateien bearbeitet." & vbCrLf & _
            AnzahlIO & " Aktionen waren erfolgreich." & vbCrLf & _
            AnzahlNIO & " Aktionen waren nicht erfolgreich."
        
    

End Sub

Public Sub Export2STP()

    Dim SuchPfad As String
    Dim LogFile As String
    Anzahl = 0
    AnzahlIO = 0
    AnzahlNIO = 0
    
    'Eingabeabfrage des Suchpfades
    Exportformular.Label1.Caption = "Export von IPT nach STP"
    Exportformular.Caption = "Export nach STP"
    Exportformular.Show
    
    'Abfrage ob gestartet werden soll
    Dim antwort As String
    antwort = MsgBox("Der Export von ipt Dateien nach STP kann mehrere Minuten, " & vbCrLf _
                & "je nach Anzahl der Dateien auch mehrere Stunden dauern." & vbCrLf _
                & " Mchten Sie fortfahren?", vbYesNo, "Achtung!")
    If antwort = vbNo Then Exit Sub
        
        SuchPfad = Exportformular.Pfad
        If Right(SuchPfad, 1) = "\" Then SuchPfad = Left(SuchPfad, Len(SuchPfad) - 1)
        

        
        ' Log-File-Generieren
        Dim fs, log
        Dim logfilename
        Set fs = CreateObject("Scripting.FileSystemObject")
        logfilename = SuchPfad & "\STP-Export_" & Date & ".log"
        Set log = fs.CreateTextFile(logfilename, True)
        
        log.writeline ("Export von IDW in STP")
        log.writeline ("*********************")
        log.writeline
        log.writeline ("Zu durchsuchendes Verzeichnis: " & SuchPfad)
        log.writeline ("Startdatum: " & Date)
        log.writeline ("Startzeit: " & Time)
        log.writeline
                      
        'Ordnerstruktur durchlaufen
        Call SearchFold(SuchPfad, log, "STP")
        
        
        log.writeline
        log.writeline
        log.writeline ("Es wurden " & Anzahl & "IPTs gefunden.")
        log.writeline ("Erfolgreich exportierte Dateien: " & AnzahlIO)
        log.writeline ("Nicht erfolgreich exportierte Dateien: " & AnzahlNIO)
        log.writeline
        log.writeline ("Endzeit: " & Time)
    
        MsgBox "Es wurden " & Anzahl & " Dateien bearbeitet." & vbCrLf & _
            AnzahlIO & " Aktionen waren erfolgreich." & vbCrLf & _
            AnzahlNIO & " Aktionen waren nicht erfolgreich."
        
    

End Sub
Public Sub Export2SAT()

    Dim SuchPfad As String
    Dim LogFile As String
    Anzahl = 0
    AnzahlIO = 0
    AnzahlNIO = 0
    
    'Eingabeabfrage des Suchpfades
    Exportformular.Label1.Caption = "Export von IPT nach SAT"
    Exportformular.Caption = "Export nach SAT"
    Exportformular.Show
    
    'Abfrage ob gestartet werden soll
    Dim antwort As String
    antwort = MsgBox("Der Export von ipt Dateien nach SAT kann mehrere Minuten, " & vbCrLf _
                & "je nach Anzahl der Dateien auch mehrere Stunden dauern." & vbCrLf _
                & " Mchten Sie fortfahren?", vbYesNo, "Achtung!")
    If antwort = vbNo Then Exit Sub
        
        SuchPfad = Exportformular.Pfad
        If Right(SuchPfad, 1) = "\" Then SuchPfad = Left(SuchPfad, Len(SuchPfad) - 1)
        

        
        ' Log-File-Generieren
        Dim fs, log
        Dim logfilename
        Set fs = CreateObject("Scripting.FileSystemObject")
        logfilename = SuchPfad & "\STP-Export_" & Date & ".log"
        Set log = fs.CreateTextFile(logfilename, True)
        
        log.writeline ("Export von IPT in SAT")
        log.writeline ("*********************")
        log.writeline
        log.writeline ("Zu durchsuchendes Verzeichnis: " & SuchPfad)
        log.writeline ("Startdatum: " & Date)
        log.writeline ("Startzeit: " & Time)
        log.writeline
                      
        'Ordnerstruktur durchlaufen
        Call SearchFold(SuchPfad, log, "SAT")
        
        
        log.writeline
        log.writeline
        log.writeline ("Es wurden " & Anzahl & "IPTs gefunden.")
        log.writeline ("Erfolgreich exportierte Dateien: " & AnzahlIO)
        log.writeline ("Nicht erfolgreich exportierte Dateien: " & AnzahlNIO)
        log.writeline
        log.writeline ("Endzeit: " & Time)
    
        MsgBox "Es wurden " & Anzahl & " Dateien bearbeitet." & vbCrLf & _
            AnzahlIO & " Aktionen waren erfolgreich." & vbCrLf & _
            AnzahlNIO & " Aktionen waren nicht erfolgreich."
        
    

End Sub

Public Sub Export2PDF()

    Dim SuchPfad As String
    Dim LogFile As String
    Anzahl = 0
    AnzahlIO = 0
    AnzahlNIO = 0
    
    'Eingabeabfrage des Suchpfades
    Exportformular.Label1.Caption = "Export von IDWs in PDFs"
    Exportformular.Caption = "Export nach PDF"
    Exportformular.Show
    
    'Abfrage ob gestartet werden soll
    Dim antwort As String
    antwort = MsgBox("Der Export von idw Dateien nach PDF kann mehrere Minuten, " & vbCrLf _
                & "je nach Anzahl der Dateien auch mehrere Stunden dauern." & vbCrLf _
                & " Mchten Sie fortfahren?", vbYesNo, "Achtung!")
    If antwort = vbNo Then Exit Sub
        
        SuchPfad = Exportformular.Pfad
        If Right(SuchPfad, 1) = "\" Then SuchPfad = Left(SuchPfad, Len(SuchPfad) - 1)
        

        
        ' Log-File-Generieren
        Dim fs, log
        Dim logfilename
        Set fs = CreateObject("Scripting.FileSystemObject")
        logfilename = SuchPfad & "\PDF-Export_" & Date & ".log"
        Set log = fs.CreateTextFile(logfilename, True)
        
        log.writeline ("Export von IDW in PDF")
        log.writeline ("*********************")
        log.writeline
        log.writeline ("Zu durchsuchendes Verzeichnis: " & SuchPfad)
        log.writeline ("Startdatum: " & Date)
        log.writeline ("Startzeit: " & Time)
        log.writeline
                      
        'Ordnerstruktur durchlaufen
        Call SearchFold(SuchPfad, log, "PDF")
        
        
        log.writeline
        log.writeline
        log.writeline ("Es wurden " & Anzahl & "IDWs gefunden.")
        log.writeline ("Erfolgreich exportierte Dateien: " & AnzahlIO)
        log.writeline ("Nicht erfolgreich exportierte Dateien: " & AnzahlNIO)
        log.writeline
        log.writeline ("Endzeit: " & Time)
    
        MsgBox "Es wurden " & Anzahl & " Dateien bearbeitet." & vbCrLf & _
            AnzahlIO & " Aktionen waren erfolgreich." & vbCrLf & _
            AnzahlNIO & " Aktionen waren nicht erfolgreich."
    
End Sub


'Durchsucht die Ordnerstruktur nach weiteren Unterordnern
Function SearchFold(folderspec, log, Ziel)
    Dim fs, f, f1, fc
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFolder(folderspec)
    Set fc = f.SubFolders
    For Each f1 In fc
        Call SearchFold(f1, log, Ziel)
        If Ziel = "STP" Or Ziel = "SAT" Then
        Call searchIPT(f1, log, Ziel)
        Else
        Call searchIDW(f1, log, Ziel)
        End If
    Next
    If folderspec = Exportformular.Pfad Then
        If Ziel = "STP" Or Ziel = "SAT" Then
        Call searchIPT(folderspec, log, Ziel)
        Else
        Call searchIDW(folderspec, log, Ziel)
        End If
    End If
        
End Function


'Durchsucht einen Ordner nach der Endung .idw
Function searchIDW(foldername, log, Ziel)
    Dim IDWs, IDW, IDW1, IDWc
    Dim ausgabe
    
    Set IDWs = CreateObject("Scripting.FileSystemObject")
    Set IDW = IDWs.GetFolder(foldername)
    Set IDWc = IDW.Files
    For Each IDW1 In IDWc
        If Right(IDW1.Name, 3) = "idw" Then
        Anzahl = Anzahl + 1
        Call openidw(foldername & "\" & IDW1.Name, log, Ziel)
        End If
    Next
    
End Function
'Durchsucht einen Ordner nach der Endung .ipt
Function searchIPT(foldername, log, Ziel)
    Dim IPTs, IPT, IPT1, IPTc
    Dim ausgabe
    
    Set IPTs = CreateObject("Scripting.FileSystemObject")
    Set IPT = IPTs.GetFolder(foldername)
    Set IPTc = IPT.Files
    For Each IPT1 In IPTc
        If Right(IPT1.Name, 3) = "ipt" Then
        Anzahl = Anzahl + 1
        Call openidw(foldername & "\" & IPT1.Name, log, Ziel)
        End If
    Next
    
End Function


'ffnet eine idw und speichert als dwg
Function openidw(FileName, log, Ziel)
    
    On Error Resume Next
    Dim newFilename As String
    Dim Laenge As Integer
    Dim oApp As Application
    Set oApp = ThisApplication
    Laenge = Len(FileName)

    Call oApp.Documents.Open(FileName, True)
    If Ziel = "DWG" Then
        newFilename = Left(FileName, Laenge - 4) & ".dwg"
        Call oApp.ActiveDocument.SaveAs(newFilename, True)
    ElseIf Ziel = "DXF" Then
        newFilename = Left(FileName, Laenge - 4) & ".dxf"
        Call oApp.ActiveDocument.SaveAs(newFilename, True)
    ElseIf Ziel = "PDF" Then
        newFilename = "Eigene Dateien\*.pdf"
        Call PDFdruck
    ElseIf Ziel = "STP" Then
        newFilename = Left(FileName, Laenge - 4) & ".stp"
        Call oApp.ActiveDocument.SaveAs(newFilename, True)
    ElseIf Ziel = "SAT" Then
        newFilename = Left(FileName, Laenge - 4) & ".sat"
        Call oApp.ActiveDocument.SaveAs(newFilename, True)
    End If
    
    
    oApp.ActiveDocument.Close True
    
    
    log.writeline (Anzahl & ":")
    log.writeline ("Ausgangsdatei: " & FileName)
    log.writeline ("Zieldatei    : " & newFilename)
    log.write ("Status: ")
    
    If Err.Number Then
        AnzahlNIO = AnzahlNIO + 1
        Err.Clear
        log.writeline ("NIO")
    Else
        AnzahlIO = AnzahlIO + 1
        log.writeline ("IO")
    End If
    
    log.writeline
    
End Function


Public Sub PDFdruck()

    Dim i As Integer
    
    Dim oApp As Application
    Set oApp = ThisApplication
    
    Dim oDoc As DrawingDocument
    Set oDoc = oApp.ActiveDocument
    
    
    'Printer Ansteuern
        
        On Error Resume Next
        Dim oPrintMgr As drawingprintmanager
        Set oPrintMgr = ThisApplication.ActiveDocument.PrintManager
        If Err.Number Then
            MsgBox "Adobe PDF Drucker ist nicht installiert"
            Err.Clear
            Exit Sub
        End If
    
        oPrintMgr.Printer = "Adobe PDF"
        oPrintMgr.ColorMode = kPrintColorPalette
        oPrintMgr.ScaleMode = kPrintBestFitScale
        If oDoc.ActiveSheet.Size = kA4DrawingSheetSize Then
            oPrintMgr.PaperSize = kPaperSizeA4
        Else
            oPrintMgr.PaperSize = kPaperSizeA3
        End If
        
        If oDoc.ActiveSheet.Orientation = kPortraitPageOrientation Then
            oPrintMgr.Orientation = kPortraitOrientation
        Else
            oPrintMgr.Orientation = kLandscapeOrientation
        End If
        oPrintMgr.PrintRange = kPrintAllSheets
        oPrintMgr.SubmitPrint
       
End Sub


